## redict 7.3.0+ds

=== debian/changelog ===
redict (7.3.0+ds-3~bpo12+1) bookworm-backports; urgency=medium

  * Rebuild for bookworm-backports.

 -- Alex Myczko <tar@debian.org>  Sun, 09 Jun 2024 06:04:54 +0200

redict (7.3.0+ds-3) unstable; urgency=medium

  [ Maytham Alsudany ]
  * Rename bash-completions to redict-cli (Closes: #1071095)

  [ Alex Myczko ]
  * d/clean: updated.

 -- Maytham Alsudany <maytha8thedev@gmail.com>  Tue, 14 May 2024 22:34:56 +0800

redict (7.3.0+ds-2) unstable; urgency=medium

  * Source-only upload
  * d/copyright: src/sds.* is licensed under LGPL-3.0-or-later, not LGPL-3.0-only.
    Thanks to Thorsten Alteholz for finding this mistake.
  * d/patches: Update patch metadata
  * d/control: Improve package descriptions

 -- Maytham Alsudany <maytha8thedev@gmail.com>  Sun, 12 May 2024 17:30:46 +0800

redict (7.3.0+ds-1) unstable; urgency=medium

  * Initial release. (Closes: #1068129)

 -- Maytham Alsudany <maytha8thedev@gmail.com>  Sun, 05 May 2024 08:46:45 +0800
