## redict 7.3.1+ds

=== debian/changelog ===
redict (7.3.1+ds-1) unstable; urgency=medium

  * New upstream version 7.3.1
    * Contains fix for CVE-2024-31228

 -- Maytham Alsudany <maytha8thedev@gmail.com>  Sat, 12 Oct 2024 11:14:49 +0800
