## redict 7.3.2%2Bds

=== debian/changelog ===
redict (7.3.2+ds-1ubuntu0.1) plucky-security; urgency=medium

  * SECURITY UPDATE: remote code execution
    - debian/patches/CVE-2025-49844.patch: protect TString on stack
      during parsing to prevent use-after-free condition in lparser.c
    - CVE-2025-49844 

 -- Sudhakar Verma <sudhakar.verma@canonical.com>  Wed, 15 Oct 2025 16:54:06 +0530

redict (7.3.2+ds-1) unstable; urgency=medium

  * New upstream version 7.3.2
    * Contains fixes for CVE-2024-46981 and CVE-2024-51741 (Closes: #1092372)

 -- Maytham Alsudany <maytha8thedev@gmail.com>  Wed, 08 Jan 2025 21:10:54 +0800
