=== debian/changelog ===
redict (7.3.2+ds-1~bpo12+1) bookworm-backports; urgency=medium

  * Rebuild for bookworm-backports.

 -- Maytham Alsudany <maytha8thedev@gmail.com>  Wed, 08 Jan 2025 22:07:23 +0800
