## redict 7.3.5+ds

=== debian/changelog ===
redict (7.3.5+ds-1ubuntu0.1) questing-security; urgency=medium

  * SECURITY UPDATE: remote code execution
    - debian/patches/CVE-2025-49844.patch: protect TString on stack
      during parsing to prevent use-after-free condition in lparser.c
    - CVE-2025-49844 

 -- Sudhakar Verma <sudhakar.verma@canonical.com>  Wed, 15 Oct 2025 16:56:05 +0530

redict (7.3.5+ds-1) unstable; urgency=medium

  * New upstream version 7.3.5
    * Contains fix for CVE-2025-21605 (Closes: #1104011)
    * Contains fix for CVE-2025-48367 (Closes: #1108980)
    * Contains fix for CVE-2025-32023 (Closes: #1108977)
  * Add patch to fix CVE-2025-27151 (Closes: #1106823)
  * Add patch to fix CVE-2025-49112 (Closes: #1107212)

 -- Maytham Alsudany <maytham@debian.org>  Sun, 03 Aug 2025 14:22:26 +0800
