=== debian/control ===
Source: redict
Section: database
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Redict Maintainers <team+redict@tracker.debian.org>
Uploaders:
 Maytham Alsudany <maytha8thedev@gmail.com>,
 Alex Myczko <tar@debian.org>
Build-Depends:
 debhelper-compat (= 13),
 dpkg-dev (>= 1.17.14),
 libhiredict-dev,
 libjemalloc-dev [linux-any],
 liblua5.1-dev,
 liblzf-dev,
 libssl-dev,
 libsystemd-dev,
 lua-bitop-dev,
 lua-cjson-dev,
 openssl <!nocheck>,
 pkgconf,
 procps <!nocheck>,
 tcl <!nocheck>,
 tcl-tls <!nocheck>,
Standards-Version: 4.7.0
Homepage: https://redict.io/
Vcs-Git: https://salsa.debian.org/redict-team/redict.git
Vcs-Browser: https://salsa.debian.org/redict-team/redict
Rules-Requires-Root: no

Package: redict
Architecture: all
Depends:
 redict-server (<< ${binary:Version}.1~),
 redict-server (>= ${binary:Version}),
 ${misc:Depends},
Description: Persistent key-value database with network interface (metapackage)
 Redict is a distributed, in-memory key/value store (a remote dictionary, if you
 will). Redict is an independent fork of Redis OSS 7.2.4 licensed under the
 Lesser GNU General Public license (LGPL-3.0-only).
 .
 This package depends on the redict-server package.

Package: redict-sentinel
Architecture: any
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 redict-tools (= ${binary:Version}),
 ${misc:Depends},
Description: Persistent key-value database with network interface (monitoring)
 Redict is a distributed, in-memory key/value store (a remote dictionary, if you
 will). Redict is an independent fork of Redis OSS 7.2.4 licensed under the
 Lesser GNU General Public license (LGPL-3.0-only).
 .
 This package contains the Redict Sentinel monitoring software.

Package: redict-server
Architecture: any
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 redict-tools (= ${binary:Version}),
 ${misc:Depends},
Description: Persistent key-value database with network interface
 Redict is a distributed, in-memory key/value store (a remote dictionary, if you
 will). Redict is an independent fork of Redis OSS 7.2.4 licensed under the
 Lesser GNU General Public license (LGPL-3.0-only).
 .
 This package contains the Redict database server.

Package: redict-tools
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Suggests:
 ruby-redis,
Description: Persistent key-value database with network interface (client)
 Redict is a distributed, in-memory key/value store (a remote dictionary, if you
 will). Redict is an independent fork of Redis OSS 7.2.4 licensed under the
 Lesser GNU General Public license (LGPL-3.0-only).
 .
 This package contains the command line client and other tools.
