## redict 7.3.6+ds

=== Makefile ===
# Top level makefile, the real shit is at src/Makefile

default: all

.DEFAULT:
	$(MAKE) -C src $@

install:
	$(MAKE) -C src $@

.PHONY: install
