=== utils/req-res-validator/requirements.txt ===
jsonschema==4.17.3
redis==4.5.1
