=== debian/changelog ===
redict (7.3.6+ds-1~bpo13+1) trixie-backports; urgency=medium

  * Rebuild for trixie-backports.

 -- Maytham Alsudany <maytham@debian.org>  Sat, 11 Oct 2025 13:15:10 +0800

redict (7.3.6+ds-1) unstable; urgency=medium

  * New upstream version 7.3.6
    * Contains fix for CVE-2025-49844, CVE-2025-46817, CVE-2025-46818,
      CVE-2025-46819 (Closes: #1117690)

 -- Maytham Alsudany <maytham@debian.org>  Sat, 11 Oct 2025 11:05:59 +0800
