=== debian/tests/control ===
Tests: 0001-redict-cli
Restrictions: needs-root

Tests: 0002-benchmark
Restrictions: needs-root

Tests: 0003-redict-check-aof
Restrictions: needs-root

Tests: 0004-redict-check-rdb
Restrictions: needs-root

Tests: 0005-cjson
Restrictions: needs-root
